vector_add() {
    local a_str="$1"
    local b_str="$2"
    local a=($a_str)
    local b=($b_str)
    local result=()
    
    for i in "${!a[@]}"; do
        result[i]=$(( a[i] + b[i] ))
    done

    echo "${result[@]}"
}

vector_subtract() {
    local a_str="$1"
    local b_str="$2"
    local a=($a_str)
    local b=($b_str)
    local result=()
    
    for i in "${!a[@]}"; do
        result[i]=$(( a[i] - b[i] ))
    done

    echo "${result[@]}"
}

calculate_percentage() {
    local input_str=$1
    local values=($input_str)
    local -i total=0
    local result=()

    for ((i = 0; i < ${#values[@]}; i++)); do
        total=$(( total + values[i] ))
    done

    for ((i = 0; i < ${#values[@]}; i++)); do
        # 使用 printf 来确保输出总是包含两位小数
        if [ $total -ne 0 ]; then
            percentage=$(echo "scale=4; ${values[i]} * 100 / $total" | bc)
        else
            percentage=0
        fi
	formatted_percentage=$(printf "%.2f" "$percentage")
        result+=("$formatted_percentage%")
    done

    echo "${result[@]}"
}

